using System;
using System.Collections.Generic;
using System.Collections; // HashTable
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions; // K\
using HongliangSoft.Utilities.Gui; // KeyboardHook

namespace KeyPlayer
{
    public partial class KeyPlayer : Form
    {
#region constructor

        /// <summary>
        /// RXgN^
        /// </summary>
        public KeyPlayer()
        {
            InitializeComponent();

            traceFrom = new TraceForm();
            #if DEBUG
                traceFrom.Show(); // fobOEBhE\
            #endif

            SideBar = false; // TCho[\
            labelDuration.Text = ""; // :

            keyFlags = new Hashtable();
            labelFileName.Text = "";
            refreshTitle(); // this.TextXV
            //R}hCzŎ擾
            string[] cmds = System.Environment.GetCommandLineArgs();
            if (cmds.Length > 1)
            {
                fileOpen(cmds[1]);
            }
            this.axWMP.settings.volume = 100; // {[ő
        }

#endregion

#region properties and accessors

        private string appVersion = "1.12"; // o[W
        private string appName = "KeyPlayer"; // AvP[V
        private string fileName = ""; // ǂݍłt@C
        private TraceForm traceFrom;
        private Hashtable keyFlags;

        /// <summary>
        /// t@C fileOpen(str)Ă΂
        /// </summary>
        private string FileName
        {
            get
            {
                return this.fileName;
            }
            set
            {
                this.fileName = value;
                this.refreshTitle();
            }
        }

        /// <summary>
        /// Đ[g 0ȉ͖̂ŋI1ɂ
        /// </summary>
        public double Rate
        {
            get{ return this.axWMP.settings.rate; }
            set
            {
                double rate = 0;
                if (value < 0.5) rate = 0.5;
                else rate = value;
                this.axWMP.settings.rate = rate;
                labelRate.Text = "Đ[g: " + rate.ToString();
            }
        }

        /// <summary>
        /// TCho[̕\
        /// </summary>
        public bool SideBar
        {
            get { return this.panelSide.Visible; }
            set
            { 
                this.panelSide.Visible = value;
                if (value) // \鎞
                {
                    this.Width += panelSide.Width; // Form̑傫
                    buttonSideBar.Text = "<<";
                }
                else // 
                {
                    this.Width -= panelSide.Width;
                    buttonSideBar.Text = ">>";
                }
            }
        }

#endregion

#region events
        /// <summary>
        /// hbOă}EX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void panelDD_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
            else
                e.Effect = DragDropEffects.None;
        }

        /// <summary>
        /// hbOăACehbv
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void panelDD_DragDrop(object sender, DragEventArgs e)
        {
            string[] items = (string[])e.Data.GetData(DataFormats.FileDrop, false);
            this.fileOpen(items[0]); // 1ڂ̃t@C
        }


        /// <summary>
        /// [xL[{[htbNŃL[Cxg擾
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void keyboardHook_KeyboardHooked(object sender, KeyboardHookedEventArgs e)
        {
            Console.WriteLine("key hook");
            if (e.UpDown == KeyboardUpDown.Down) keyFlags[e.KeyCode] = true; // ĂL[
            else keyFlags.Remove(e.KeyCode); // ĂȂL[

            if (
                (
                (keyFlags.Contains(Keys.LControlKey)||keyFlags.Contains(Keys.RControlKey))
                && (keyFlags.Contains(Keys.LShiftKey)||keyFlags.Contains(Keys.RShiftKey))
                ) // Ctrl+Shift
                || ActiveForm == this // ̓tH[̂ANeBu̎
                || axWMP.fullScreen // ̓tXN[̎
                )
            {
                if (axWMP.URL != "" && e.UpDown == KeyboardUpDown.Down) // alt
                {
                    int sec = 0; // ߂ori߂b
                    switch (e.KeyCode)
                    { // ꂽL[
                        case Keys.Shift:
                            sec = 15;
                            break;
                        case Keys.Oemcomma: // J}
                            sec = -5; // 5b߂
                            break;
                        case Keys.OemPeriod: // sIh
                            sec = 5; // 5bi߂
                            break;
                        case Keys.B:
                            sec = -2;
                            break;
                        case Keys.N:
                            sec = 2;
                            break;
                        case Keys.Space: // Xy[XL[
                            switch (axWMP.playState.ToString()) // wmp̍Đ
                            {
                                case "wmppsPlaying": // Đ
                                    axWMP.Ctlcontrols.pause(); // ꎞ~
                                    break;
                                case "wmppsPaused": // ꎟ~
                                case "wmppsStopped": // ~
                                    axWMP.Ctlcontrols.play(); // Đ
                                    break;
                            }
                            break;
                    }
                    if (sec != 0) // ior߂Ȃ
                    {
                        if (axWMP.playState.ToString() == "wmppsPlaying") // ĐȂ
                        {
                            axWMP.Ctlcontrols.pause(); // ꎞ~
                            timerKeyPlay.Enabled = false;
                            timerKeyPlay.Enabled = true; // ^C}NA0.3bĐ
                        }
                        axWMP.Ctlcontrols.currentPosition += sec; // i߂or߂

                    }

                }

            }
        }

        /// <summary>
        /// Aő҂^C}[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timerKeyPlay_Tick(object sender, EventArgs e)
        {
            axWMP.Ctlcontrols.play(); // Đ
            timerKeyPlay.Enabled = false;
        }

        /// <summary>
        /// t@CJHɋNCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void axWMP_OpenStateChange(object sender, AxWMPLib._WMPOCXEvents_OpenStateChangeEvent e)
        {
            labelDuration.Text = ": " + axWMP.currentMedia.durationString;
        }

#endregion

#region UI events

        /// <summary>
        /// TCho[\{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonSideBar_Click(object sender, EventArgs e)
        {
            SideBar = !SideBar; // \gO
            this.ActiveControl = null; // L[tbN̎זɂȂ
        }

        /// <summary>
        /// `FbN{bNXuɍőOʂɕ\v
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBoxShowAlways_CheckedChanged(object sender, EventArgs e)
        {
            this.TopMost = checkBoxShowAlways.Checked;
            this.ActiveControl = null;
        }

        /// <summary>
        /// gbNo[ Đ[g
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void trackBarRate_Scroll(object sender, EventArgs e)
        {
            double rate = trackBarRate.Value / 100.0;
            if (rate < 1.15 && 0.85 < rate)
            {
                rate = 1.0;
                trackBarRate.Value = (int)rate * 100;
            }
            this.Rate = rate;

            this.ActiveControl = null;
        }

#endregion

#region methods
        /// <summary>
        /// t@CJ
        /// </summary>
        /// <param name="path">t@C̃pX</param>
        public void fileOpen(string path)
        {
            axWMP.URL = path;
            labelFileName.Text = path;
            string[] str = path.Split(new char[] { '\\' });
            FileName = str[str.Length - 1]; // t@C
        }

        /// <summary>
        /// ^Cgo[ this.TextXV
        /// </summary>
        private void refreshTitle()
        {
            this.Text = "";
            if (FileName != "") this.Text = FileName + " - ";
            this.Text += appName + " ver." + appVersion;
        }

#endregion

    }
}